#include<bits/stdc++.h>
#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define sz(x) ((ll)x.size())
#define all(x) (x.begin(), x.end())

//#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using ll = long long;
using ull = unsigned long long;
using namespace std;

const ll MAXN = 1e6;
const ll MAXK = 10;
ll n, k;
vector<ll> a;
ll dp[MAXN][MAXK];
ll ans;

void input() {
    cin>>n>>k;

    ll temp;
    for (ll i=0; i<n; i++) {
        cin>>temp;
        ll l = a.size();
        if (l == 1 && a[l-1] >= temp) {
            a.pop_back();
        }
        if (l > 1) {
            if (a[l-2] > a[l-1]) {
                if (a[l-1] >= temp) {
                    a.pop_back();
                }
            } else {
                if (a[l-1] <= temp) {
                    a.pop_back();
                }
            }
        }
        a.pb(temp);
    }
    n = a.size();
    if (n > 1 && a[n-1] < a[n-2]) {
        a.pop_back();
        n--;
    }

    /*for (ll i=0; i<a.size(); i++) {
        cout<<a[i]<<' ';
    }cerr<<endl;*/
}

void output() {
    cout<<ans<<endl;
}

void solve() {
    if (n < 2) {
        return;
    }
    vector<ll> mxd(k);
    vector<ll> mx(k);
    for (ll i=0; i<n/2; i++) {
        //cerr<<i<<" - ";
        for (ll j=0; j<k; j++) {
            if (i == 0) {
                mx[j] = -a[0];
                mxd[j] = -a[0];
            } else {
                mx[j] = max(mx[j], dp[i-1][j+1]);
                mxd[j] = max(mxd[j], mx[j] - a[i*2]);
            }
            //cerr<<mxd[j]<<' ';
            dp[i][j] = a[i*2+1] + mxd[j];
        }
        //cerr<<endl;
    }
    for (ll i=0; i<n/2; i++) {
        ans = max(ans, dp[i][0]);
        //cerr<<dp[i][0]<<endl;
    }
}

void solveK2() {
    vector<ll> cl(n+2, 0);
    ll mx = a[n-1];
    for (ll i=n-1; i>=0; i-=2) {
        mx = max(a[i], mx);
        cl[i] = max(cl[i+2], mx - a[i-1]);
    }

    ll mn = a[0];
    for (ll i=1; i<n; i+=2) {
        mn = min(a[i-1], mn);
        ans = max(ans, a[i] - mn + cl[i+2]);
    }
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    input();
    if (k == 2) {
        solve();
    } else {
        solve();
    }
    output();
    return 0;
}

/*
7 2
3 9 4 6 3 8 9
*/


